=== debian/changelog ===
libphonenumber (8.13.51+ds-4.2ubuntu1) questing; urgency=medium

  * cpp/tests/phonenumberutil_test.cc : escape bidirectional unicode
    character to fix FTBFS  due to gcc-15 and -Werror=bidi-char=
    (LP: #2124964)

 -- John Chittum <john.chittum@canonical.com>  Tue, 23 Sep 2025 09:24:34 -0400

libphonenumber (8.13.51+ds-4.2build1) questing; urgency=medium

  * Rebuild against latest abseil

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 03 May 2025 11:12:49 -0400

libphonenumber (8.13.51+ds-4.2) unstable; urgency=medium

  * Non-maintainer upload.

  [ Matthias Klose ]
  * libphonenumber-dev: Explicitly depend on libicu-dev. (Closes: #1101095)

 -- Bastian Germann <bage@debian.org>  Sun, 23 Mar 2025 17:37:53 +0100

libphonenumber (8.13.51+ds-4.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Matthias Klose ]
  * Don't explicitly build with c++14 standard. (Closes: #1092351)

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 15 Mar 2025 12:32:09 +0100

libphonenumber (8.13.51+ds-4) unstable; urgency=medium

  * d/rules: Do not compress .xml files

 -- Matthias Geiger <werdahias@debian.org>  Mon, 09 Dec 2024 09:04:57 +0100

libphonenumber (8.13.51+ds-3) unstable; urgency=medium

  * Team upload.
  * Reinstate t64 Provides:

 -- Matthias Geiger <werdahias@debian.org>  Mon, 09 Dec 2024 00:08:07 +0100

libphonenumber (8.13.51+ds-2) unstable; urgency=medium

  * Team upload.
  * Source-only upload

 -- Matthias Geiger <werdahias@debian.org>  Sun, 08 Dec 2024 23:30:13 +0100

libphonenumber (8.13.51+ds-1) unstable; urgency=medium

  * Team upload
  * New upstream version 8.13.51+ds
  * d/copyright: Update Files-Excluded list for new upstream
  * d/p: Refresh for new upstream, drop obsolete patches, cleanup series file
  * d/control: Depend on libgoogle-auto-value-java
  * libphonenumber-dev: Stop installing static library; include cmake files
  * d/rules: set hardening=+all
  * Updated lintian-overrides file for libphonenumber8-java
  * d/rules: Directly build with C++ 14; drop obsolete patch for this
  * Add d/u/metadata file
  * Set DEP-3 header for patches whose origin is clear
  * Ship resources/* in a libphonenumber-data package (Closes: #1089205)
  * d/gbp.conf: Add postimport section
  * Add d/salsa-ci.yml
  * Bump Standards-Version to 4.7.0; no changes needed
  * d/copyright: Update for new upstream

 -- Matthias Geiger <werdahias@debian.org>  Sun, 08 Dec 2024 23:27:38 +0100

libphonenumber (8.12.57+ds-4) unstable; urgency=medium

  * Team upload.
  * Use C++14 to resolve FTBFS with googletest 1.13.0 (Closes: #1041075)
    Thank you to Adrian Bunk for the patch

 -- tony mancill <tmancill@debian.org>  Wed, 19 Jul 2023 21:36:41 -0700
