=== debian/watch ===
version=4
opts="repacksuffix=+ds,dversionmangle=s/\+ds//,repack" \
    https://github.com/googlei18n/libphonenumber/tags \
    .*/libphonenumber/archive/.*?(\d[\d\.]+).*\.tar\.gz
